// Algorand.ts
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { keccak256 } from "ethers/lib/utils";
import algosdk, { Algodv2, assignGroupID, bigIntToBytes, decodeAddress, encodeAddress, getApplicationAddress, Indexer, LogicSigAccount, makeApplicationCallTxnFromObject, makeApplicationOptInTxnFromObject, makeAssetTransferTxnWithSuggestedParamsFromObject, makePaymentTxnWithSuggestedParamsFromObject, OnApplicationComplete, signLogicSigTransaction, waitForConfirmation, } from "algosdk";
import { hexStringToUint8Array, TmplSig, uint8ArrayToHexString, } from "./TmplSig";
import { TextEncoder } from "util";
export var ALGO_TOKEN = "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa";
export var ALGOD_ADDRESS = "http://localhost";
export var ALGOD_PORT = 4001;
export var CORE_ID = 4;
export var TOKEN_BRIDGE_ID = 6;
export var SEED_AMT = 1002000;
var ZERO_PAD_BYTES = "0000000000000000000000000000000000000000000000000000000000000000";
var MAX_KEYS = 15;
var MAX_BYTES_PER_KEY = 127;
var BITS_PER_BYTE = 8;
var BITS_PER_KEY = MAX_BYTES_PER_KEY * BITS_PER_BYTE;
var MAX_BYTES = MAX_BYTES_PER_KEY * MAX_KEYS;
var MAX_BITS = BITS_PER_BYTE * MAX_BYTES;
var COST_PER_VERIF = 1000;
var MAX_SIGS_PER_TXN = 9;
var INDEXER_TOKEN = "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa";
var INDEXER_ADDRESS = "http://localhost";
var INDEXER_PORT = 8980;
// Generated Testnet wallet
export var TESTNET_ACCOUNT_ADDRESS = "RWVYXYLSV32QIHFUMBEBW4BQZR7FDVJGKTVZIVYECMQWU7CZUAK5Q4WMP4";
export var TESTNET_ACCOUNT_MN = "enforce sail meat library retreat rain praise run floor drastic flat end true olympic boy dune dust regular feed allow top universe borrow able ginger";
var ALGO_VERIFY_HASH = "EZATROXX2HISIRZDRGXW4LRQ46Z6IUJYYIHU3PJGP7P5IQDPKVX42N767A";
var ALGO_VERIFY = new Uint8Array([
    6, 32, 4, 1, 0, 32, 20, 38, 1, 0, 49, 32, 50, 3, 18, 68, 49, 1, 35, 18, 68,
    49, 16, 129, 6, 18, 68, 54, 26, 1, 54, 26, 3, 54, 26, 2, 136, 0, 3, 68, 34,
    67, 53, 2, 53, 1, 53, 0, 40, 53, 240, 40, 53, 241, 52, 0, 21, 53, 5, 35, 53,
    3, 35, 53, 4, 52, 3, 52, 5, 12, 65, 0, 68, 52, 1, 52, 0, 52, 3, 129, 65, 8,
    34, 88, 23, 52, 0, 52, 3, 34, 8, 36, 88, 52, 0, 52, 3, 129, 33, 8, 36, 88,
    7, 0, 53, 241, 53, 240, 52, 2, 52, 4, 37, 88, 52, 240, 52, 241, 80, 2, 87,
    12, 20, 18, 68, 52, 3, 129, 66, 8, 53, 3, 52, 4, 37, 8, 53, 4, 66, 255, 180,
    34, 137,
]);
// Globals?
var IndexerInfo = /** @class */ (function () {
    function IndexerInfo() {
        this.round = 0;
        this.round = 0;
        this.client = new Indexer(INDEXER_TOKEN, INDEXER_ADDRESS, INDEXER_PORT);
    }
    IndexerInfo.getInstance = function () {
        if (!IndexerInfo.instance) {
            IndexerInfo.instance = new IndexerInfo();
        }
        return IndexerInfo.instance;
    };
    return IndexerInfo;
}());
/**
 * <p> Creates a new Algodv2 client using local file consts</p>
 * @returns a newly constructed Algodv2 client
 */
export function getAlgoClient() {
    var algodClient = new Algodv2(ALGO_TOKEN, ALGOD_ADDRESS, ALGOD_PORT);
    return algodClient;
}
// Conversion functions
export function textToHexString(name) {
    // const enc: TextEncoder = new TextEncoder();
    // const bName: Uint8Array = enc.encode(name);
    // const sName: string = uint8ArrayToHexString(bName, false);
    // return sName;
    return Buffer.from(name, "binary").toString("hex");
}
export function textToUint8Array(name) {
    var enc = new TextEncoder();
    var bName = enc.encode(name);
    return bName;
}
export function appIdToAppAddr(appId) {
    var appAddr = getApplicationAddress(appId);
    var decAppAddr = decodeAddress(appAddr).publicKey;
    var aa = uint8ArrayToHexString(decAppAddr, false);
    return aa;
}
/**
 * <p> Return the balances of all assets for the supplied account</p>
 * @param client An Algodv2 client
 * @param account The account containing assets
 * @returns Map of asset index to qty
 */
export function getBalances(client, account) {
    return __awaiter(this, void 0, void 0, function () {
        var balances, accountInfo, assets;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    balances = new Map();
                    return [4 /*yield*/, client.accountInformation(account).do()];
                case 1:
                    accountInfo = _a.sent();
                    console.log("Account Info:", accountInfo);
                    console.log("Account Info|created-assets:", accountInfo["created-assets"]);
                    // Put the algo balance in key 0
                    balances.set(0, accountInfo.amount);
                    assets = accountInfo.assets;
                    console.log("assets", assets);
                    assets.forEach(function (asset) {
                        console.log("inside foreach", asset);
                        var assetId = asset["asset-id"];
                        var amount = asset.amount;
                        balances.set(assetId, amount);
                    });
                    console.log("balances", balances);
                    return [2 /*return*/, balances];
            }
        });
    });
}
/**
 * <p>Return the balance of the supplied asset index for the supplied account</p>
 * @param client An Algodv2 client
 * @param account The account to query for the supplied asset index
 * @param key The asset index
 * @returns The quantity of the asset in the supplied account
 */
export function getBalance(client, account, key) {
    return __awaiter(this, void 0, void 0, function () {
        var balances, accountInfo, ret, assets;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    balances = new Map();
                    return [4 /*yield*/, client.accountInformation(account).do()];
                case 1:
                    accountInfo = _a.sent();
                    if (key == 0) {
                        return [2 /*return*/, accountInfo.amount];
                    }
                    ret = 0;
                    assets = accountInfo.assets;
                    assets.forEach(function (asset) {
                        if (key === asset["asset-id"]) {
                            ret = asset.amount;
                            return;
                        }
                    });
                    return [2 /*return*/, ret];
            }
        });
    });
}
/**
 * <p>Return the message fee for the core bridge</p>
 * @returns The message fee for the core bridge
 */
export function getMessageFee(client) {
    return __awaiter(this, void 0, void 0, function () {
        var applInfo, globalState, key, ret;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, client
                        .getApplicationByID(CORE_ID)
                        .do()];
                case 1:
                    applInfo = _a.sent();
                    globalState = applInfo["params"]["global-state"];
                    console.log("globalState:", globalState);
                    key = Buffer.from("MessageFee", "binary").toString("base64");
                    console.log("key", key);
                    ret = -1;
                    globalState.forEach(function (el) {
                        if (el["key"] === key) {
                            ret = el["value"]["uint"];
                            return;
                        }
                    });
                    return [2 /*return*/, ret];
            }
        });
    });
}
/**
 * <p>Parses the logs of a transaction looking for the sequence number</p>
 * @param txn The transaction containing a sequence number
 * @returns The sequence number found in the supplied transaction
 */
export function parseSeqFromLog(txn) {
    var innerTxns = txn.innerTxns[-1];
    var logs = innerTxns["logs"];
    var seqNum = logs[0];
    var bufSN = Buffer.from(seqNum, "base64");
    var sn = bufSN.readBigUInt64BE();
    return sn;
}
/**
 * <p>Attest an already created asset</p>
 * If you create a new asset on algorand and want to transfer it elsewhere,
 * you create an attestation for it on algorand... pass that vaa to the target chain..
 * submit it.. then you can transfer from algorand to that target chain
 * @param client An Algodv2 client
 * @param senderAcct The account paying fees
 * @param assetId The asset index
 * @returns Transaction ID
 */
export function attestFromAlgorand(client, senderAcct, assetId) {
    return __awaiter(this, void 0, void 0, function () {
        var appIndex, tbAddr, decTbAddr, aa, emitterAddr, acctInfo, assetKey, createdAssets, ca, creatorAddr, creatorAcctInfo, bPgmName, wormhole, suggParams, txns, firstTxn, mfee, feeTxn, appTxn;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("senderAcct:", senderAcct, "assetId:", assetId);
                    appIndex = 0;
                    tbAddr = getApplicationAddress(TOKEN_BRIDGE_ID);
                    decTbAddr = decodeAddress(tbAddr).publicKey;
                    aa = uint8ArrayToHexString(decTbAddr, false);
                    console.log("Getting emitter address...");
                    return [4 /*yield*/, optin(client, senderAcct, CORE_ID, 0, aa, "attestFromAlgorand::emitterAddr")];
                case 1:
                    emitterAddr = _a.sent();
                    console.log("Got emitter address...");
                    return [4 /*yield*/, client.accountInformation(senderAcct.addr).do()];
                case 2:
                    acctInfo = _a.sent();
                    console.log("Got sender account info...", acctInfo);
                    assetKey = "index: " + assetId.toString();
                    console.log(assetKey, "assetKey value:", acctInfo["created-assets"][assetKey]);
                    createdAssets = acctInfo["created-assets"];
                    console.log("createdAssets:", createdAssets);
                    ca = /** @class */ (function () {
                        function ca() {
                            this.index = 0;
                        }
                        return ca;
                    }());
                    creatorAddr = "";
                    createdAssets.forEach(function (a) {
                        if (a.index === assetId) {
                            // console.log("found asset index", a.index);
                            // console.log(a);
                            creatorAddr = a.params.creator;
                            return;
                        }
                    });
                    console.log("creatorAddr:", creatorAddr);
                    return [4 /*yield*/, client.accountInformation(creatorAddr).do()];
                case 3:
                    creatorAcctInfo = _a.sent();
                    console.log("Got creator account info...");
                    bPgmName = textToUint8Array("attestToken");
                    wormhole = creatorAcctInfo["auth-addr"] === tbAddr;
                    if (!!wormhole) return [3 /*break*/, 5];
                    console.log("Not wormhole.  Need to optin...");
                    return [4 /*yield*/, optin(client, senderAcct, TOKEN_BRIDGE_ID, assetId, textToHexString("native"), "notWormhole")];
                case 4:
                    creatorAddr = _a.sent();
                    _a.label = 5;
                case 5: return [4 /*yield*/, client
                        .getTransactionParams()
                        .do()];
                case 6:
                    suggParams = _a.sent();
                    txns = [];
                    firstTxn = makeApplicationCallTxnFromObject({
                        from: senderAcct.addr,
                        appIndex: TOKEN_BRIDGE_ID,
                        onComplete: OnApplicationComplete.NoOpOC,
                        appArgs: [textToUint8Array("nop")],
                        suggestedParams: suggParams,
                    });
                    txns.push(firstTxn);
                    return [4 /*yield*/, getMessageFee(client)];
                case 7:
                    mfee = _a.sent();
                    if (mfee > 0) {
                        feeTxn = makePaymentTxnWithSuggestedParamsFromObject({
                            from: senderAcct.addr,
                            suggestedParams: suggParams,
                            to: getApplicationAddress(TOKEN_BRIDGE_ID),
                            amount: mfee,
                        });
                        txns.push(feeTxn);
                    }
                    console.log("make app call txn...");
                    appTxn = makeApplicationCallTxnFromObject({
                        appArgs: [bPgmName, bigIntToBytes(assetId, 8)],
                        accounts: [
                            emitterAddr,
                            creatorAddr,
                            creatorAcctInfo["address"],
                            getApplicationAddress(CORE_ID),
                        ],
                        appIndex: TOKEN_BRIDGE_ID,
                        foreignApps: [CORE_ID],
                        foreignAssets: [assetId],
                        from: senderAcct.addr,
                        onComplete: OnApplicationComplete.NoOpOC,
                        suggestedParams: suggParams,
                    });
                    if (mfee > 0) {
                        appTxn.fee *= 3;
                    }
                    else {
                        appTxn.fee *= 2;
                    }
                    txns.push(appTxn);
                    return [4 /*yield*/, simpleSignVAA(client, senderAcct, txns)];
                case 8:
                    _a.sent();
                    return [2 /*return*/, txns[txns.length - 1].txID()];
            }
        });
    });
}
/**
 * <p>Checks to see it the account exists for the application</p>
 * @param client An Algodv2 client
 * @param appId Application ID
 * @param acctAddr Account address to check
 * @returns true, if account exists for application.  Otherwise, returns false
 */
export function accountExists(client, appId, acctAddr) {
    return __awaiter(this, void 0, void 0, function () {
        var ret, acctInfo, als, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    ret = false;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, client.accountInformation(acctAddr).do()];
                case 2:
                    acctInfo = _a.sent();
                    console.log("appId", appId, "acctAddr", acctAddr, "acctInfo:", acctInfo);
                    als = acctInfo["apps-local-state"];
                    if (!als) {
                        return [2 /*return*/, ret];
                    }
                    als.forEach(function (app) {
                        console.log("Inside for loop");
                        if (app["id"] === appId) {
                            ret = true;
                            return;
                        }
                    });
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    console.error("Failed to check for account existence:", e_1);
                    return [3 /*break*/, 4];
                case 4:
                    console.log("returning", ret);
                    return [2 /*return*/, ret];
            }
        });
    });
}
export function optin(client, sender, appId, appIndex, emitterId, why) {
    return __awaiter(this, void 0, void 0, function () {
        var appAddr, decAppAddr, aa, data, ts, lsa, sigAddr, retval, params, seedTxn, optinTxn, rekeyTxn, txns, signedSeedTxn, signedOptinTxn, signedRekeyTxn, txnId, confirmedTxns;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("optin called with ", appIndex, emitterId, why);
                    appAddr = getApplicationAddress(appId);
                    decAppAddr = decodeAddress(appAddr).publicKey;
                    aa = uint8ArrayToHexString(decAppAddr, false);
                    data = {
                        addrIdx: appIndex,
                        appAddress: aa,
                        appId: appId,
                        emitterId: emitterId,
                        seedAmt: SEED_AMT,
                    };
                    ts = new TmplSig(client);
                    return [4 /*yield*/, ts.populate(data)];
                case 1:
                    lsa = _a.sent();
                    sigAddr = lsa.address();
                    // Check to see if we need to create this
                    console.log("Checking to see if account exists...", appIndex, "-", emitterId);
                    return [4 /*yield*/, accountExists(client, appId, sigAddr)];
                case 2:
                    retval = _a.sent();
                    if (!!retval) return [3 /*break*/, 6];
                    console.log("Account does not exist.");
                    // These are the suggested params from the system
                    console.log("Getting parms...");
                    return [4 /*yield*/, client.getTransactionParams().do()];
                case 3:
                    params = _a.sent();
                    console.log("Creating payment txn...");
                    seedTxn = makePaymentTxnWithSuggestedParamsFromObject({
                        from: sender.addr,
                        to: sigAddr,
                        amount: SEED_AMT,
                        suggestedParams: params,
                    });
                    console.log("Creating optin txn...");
                    optinTxn = makeApplicationOptInTxnFromObject({
                        from: sigAddr,
                        suggestedParams: params,
                        appIndex: appId,
                    });
                    console.log("Creating rekey txn...");
                    rekeyTxn = makePaymentTxnWithSuggestedParamsFromObject({
                        from: sigAddr,
                        to: sigAddr,
                        amount: 0,
                        suggestedParams: params,
                        rekeyTo: appAddr,
                    });
                    console.log("Assigning group ID...");
                    txns = [seedTxn, optinTxn, rekeyTxn];
                    assignGroupID(txns);
                    console.log("Signing seed for optin...");
                    signedSeedTxn = seedTxn.signTxn(sender.sk);
                    console.log("Signing optin for optin...");
                    signedOptinTxn = signLogicSigTransaction(optinTxn, lsa);
                    console.log("Signing rekey for optin...");
                    signedRekeyTxn = signLogicSigTransaction(rekeyTxn, lsa);
                    console.log("Sending txns for optin...", appIndex, "-", emitterId, "-", sigAddr);
                    return [4 /*yield*/, client
                            .sendRawTransaction([
                            signedSeedTxn,
                            signedOptinTxn.blob,
                            signedRekeyTxn.blob,
                        ])
                            .do()];
                case 4:
                    txnId = _a.sent();
                    console.log("Awaiting confirmation for optin...", appIndex, "-", emitterId);
                    return [4 /*yield*/, algosdk.waitForConfirmation(client, txns[txns.length - 1].txID(), 1)];
                case 5:
                    confirmedTxns = _a.sent();
                    console.log("optin confirmation", confirmedTxns);
                    _a.label = 6;
                case 6: return [2 /*return*/, sigAddr];
            }
        });
    });
}
export function getLogicSigAccount(program) {
    var lsa = new LogicSigAccount(program);
    return lsa;
}
function extract3(buffer, start, size) {
    return buffer.slice(start, start + size);
}
/**
 * <p>Parses the VAA into a Map</p>
 * @param vaa The VAA to be parsed
 * @returns The Map<string, any> containing the parsed elements of the VAA
 */
export function parseVAA(vaa) {
    var ret = new Map();
    var buf = Buffer.from(vaa);
    ret.set("version", buf.readIntBE(0, 1));
    ret.set("index", buf.readIntBE(1, 4));
    ret.set("siglen", buf.readIntBE(5, 1));
    var siglen = ret.get("siglen");
    if (siglen) {
        ret.set("signatures", extract3(vaa, 6, siglen * 66));
    }
    var sigs = [];
    for (var i = 0; i < siglen; i++) {
        var start = 6 + i * 66;
        var len = 66;
        var sigBuf = extract3(vaa, start, len);
        sigs.push(sigBuf);
    }
    ret.set("sigs", sigs);
    var off = siglen * 66 + 6;
    ret.set("digest", vaa.slice(off)); // This is what is actually signed...
    ret.set("timestamp", buf.readIntBE(off, 4));
    off += 4;
    ret.set("nonce", buf.readIntBE(off, 4));
    off += 4;
    ret.set("chainRaw", Buffer.from(extract3(vaa, off, 2)).toString("hex"));
    ret.set("chain", buf.readIntBE(off, 2));
    off += 2;
    ret.set("emitter", Buffer.from(extract3(vaa, off, 32)).toString("hex"));
    off += 32;
    ret.set("sequence", buf.readBigUInt64BE(off));
    off += 8;
    ret.set("consistency", buf.readIntBE(off, 1));
    off += 1;
    ret.set("Meta", "Unknown");
    if (!Buffer.compare(extract3(buf, off, 32), Buffer.from("000000000000000000000000000000000000000000546f6b656e427269646765", "hex"))) {
        ret.set("Meta", "TokenBridge");
        ret.set("module", extract3(vaa, off, 32));
        off += 32;
        ret.set("action", buf.readIntBE(off, 1));
        off += 1;
        if (ret.get("action") === 1) {
            ret.set("Meta", "TokenBridge RegisterChain");
            ret.set("targetChain", buf.readIntBE(off, 2));
            off += 2;
            ret.set("EmitterChainID", buf.readIntBE(off, 2));
            off += 2;
            ret.set("targetEmitter", extract3(vaa, off, 32));
            off += 32;
        }
        else if (ret.get("action") === 2) {
            ret.set("Meta", "TokenBridge UpgradeContract");
            ret.set("targetChain", buf.readIntBE(off, 2));
            off += 2;
            ret.set("newContract", extract3(vaa, off, 32));
            off += 32;
        }
    }
    else if (!Buffer.compare(extract3(buf, off, 32), Buffer.from("00000000000000000000000000000000000000000000000000000000436f7265", "hex"))) {
        ret.set("Meta", "CoreGovernance");
        ret.set("module", extract3(vaa, off, 32));
        off += 32;
        ret.set("action", buf.readIntBE(off, 1));
        off += 1;
        ret.set("targetChain", buf.readIntBE(off, 2));
        off += 2;
        ret.set("NewGuardianSetIndex", buf.readIntBE(off, 4));
    }
    //    ret.set("len", vaa.slice(off).length)
    //    ret.set("act", buf.readIntBE(off, 1))
    if (vaa.slice(off).length === 100 && buf.readIntBE(off, 1) === 2) {
        ret.set("Meta", "TokenBridge Attest");
        ret.set("Type", buf.readIntBE(off, 1));
        off += 1;
        ret.set("Contract", extract3(vaa, off, 32));
        off += 32;
        ret.set("FromChain", buf.readIntBE(off, 2));
        off += 2;
        ret.set("Decimals", buf.readIntBE(off, 1));
        off += 1;
        ret.set("Symbol", extract3(vaa, off, 32));
        off += 32;
        ret.set("Name", extract3(vaa, off, 32));
    }
    if (vaa.slice(off).length === 133 && buf.readIntBE(off, 1) === 1) {
        ret.set("Meta", "TokenBridge Transfer");
        ret.set("Type", buf.readIntBE(off, 1));
        off += 1;
        ret.set("Amount", extract3(vaa, off, 32));
        off += 32;
        ret.set("Contract", extract3(vaa, off, 32));
        off += 32;
        ret.set("FromChain", buf.readIntBE(off, 2));
        off += 2;
        ret.set("ToAddress", extract3(vaa, off, 32));
        off += 32;
        ret.set("ToChain", buf.readIntBE(off, 2));
        off += 2;
        ret.set("Fee", extract3(vaa, off, 32));
    }
    if (off >= buf.length) {
        console.log("No payload.");
        return ret;
    }
    if (buf.readIntBE(off, 1) === 3) {
        ret.set("Meta", "TokenBridge Transfer With Payload");
        ret.set("Type", buf.readIntBE(off, 1));
        off += 1;
        ret.set("Amount", extract3(vaa, off, 32));
        off += 32;
        ret.set("Contract", extract3(vaa, off, 32));
        off += 32;
        ret.set("FromChain", buf.readIntBE(off, 2));
        off += 2;
        ret.set("ToAddress", extract3(vaa, off, 32));
        off += 32;
        ret.set("ToChain", buf.readIntBE(off, 2));
        off += 2;
        ret.set("Fee", extract3(vaa, off, 32));
        off += 32;
        ret.set("Payload", vaa.slice(off));
    }
    return ret;
}
export function decodeLocalState(client, appId, address) {
    return __awaiter(this, void 0, void 0, function () {
        var app_state, ai, _a, _b, app, ret, e, m, vals, app_state_1, app_state_1_1, kv, k, key, v;
        var e_2, _c, e_3, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    app_state = null;
                    return [4 /*yield*/, client.accountInformation(address).do()];
                case 1:
                    ai = _e.sent();
                    try {
                        for (_a = __values(ai["apps-local-state"]), _b = _a.next(); !_b.done; _b = _a.next()) {
                            app = _b.value;
                            if (app["id"] === appId) {
                                app_state = app["key-value"];
                                break;
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                    ret = Buffer.alloc(0);
                    if (app_state) {
                        e = Buffer.alloc(127);
                        m = Buffer.from("meta");
                        vals = new Map();
                        try {
                            for (app_state_1 = __values(app_state), app_state_1_1 = app_state_1.next(); !app_state_1_1.done; app_state_1_1 = app_state_1.next()) {
                                kv = app_state_1_1.value;
                                k = Buffer.from(kv["key"], "base64");
                                if (!Buffer.compare(k, m)) {
                                    continue;
                                }
                                key = k.readInt8();
                                v = Buffer.from(kv["value"]["bytes"], "base64");
                                if (Buffer.compare(v, e)) {
                                    vals.set(key, v);
                                }
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (app_state_1_1 && !app_state_1_1.done && (_d = app_state_1.return)) _d.call(app_state_1);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                        vals.forEach(function (v) {
                            ret = Buffer.concat([ret, v]);
                        });
                    }
                    return [2 /*return*/, new Uint8Array(ret)];
            }
        });
    });
}
export function assetOptinCheck(client, asset, receiver) {
    return __awaiter(this, void 0, void 0, function () {
        var acctInfo, assets, ret;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, client.accountInformation(receiver).do()];
                case 1:
                    acctInfo = _a.sent();
                    assets = acctInfo.assets;
                    console.log("assets", assets);
                    ret = false;
                    assets.forEach(function (asset) {
                        console.log("inside foreach", asset);
                        var assetId = asset["asset-id"];
                        if (assetId === asset) {
                            ret = true;
                            return;
                        }
                    });
                    return [2 /*return*/, ret];
            }
        });
    });
}
export function assetOptin(client, sender, asset, receiver) {
    return __awaiter(this, void 0, void 0, function () {
        var params, optinTxn, signedOptinTxn, txId, confirmedTxn;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, client
                        .getTransactionParams()
                        .do()];
                case 1:
                    params = _a.sent();
                    optinTxn = makeAssetTransferTxnWithSuggestedParamsFromObject({
                        amount: 0,
                        assetIndex: asset,
                        from: sender.addr,
                        suggestedParams: params,
                        to: receiver,
                    });
                    signedOptinTxn = optinTxn.signTxn(sender.sk);
                    return [4 /*yield*/, client.sendRawTransaction(signedOptinTxn).do()];
                case 2:
                    txId = _a.sent();
                    return [4 /*yield*/, waitForConfirmation(client, txId, 4)];
                case 3:
                    confirmedTxn = _a.sent();
                    console.log("assetOptin confirmation:", confirmedTxn);
                    // Double check the result
                    if (!assetOptinCheck(client, asset, receiver)) {
                        throw new Error("assetOptin() failed ");
                    }
                    return [2 /*return*/];
            }
        });
    });
}
var SubmitVAAState = /** @class */ (function () {
    function SubmitVAAState(vaaMap, accounts, txns, guardianAddr) {
        this.vaaMap = vaaMap;
        this.accounts = accounts;
        this.txns = txns;
        this.guardianAddr = guardianAddr;
    }
    return SubmitVAAState;
}());
/**
 * <p>Submits just the header of the VAA</p>
 * @param vaa The VAA (Just the header is used)
 * @param client AlgodV2 client
 * @param sender Sending account
 * @param appid Application ID
 * @returns Current VAA state
 */
export function submitVAAHdr(vaa, client, sender, appid) {
    return __awaiter(this, void 0, void 0, function () {
        var parsedVAA, seq, chainRaw, em, index, seqAddr, guardianPgmName, guardianAddr, accts, keys, params, txns, digest, numSigs, numTxns, SIG_LEN, BSIZE, signatures, verifySigArg, nt, sigs, GuardianKeyLen, numSigsThisTxn, arraySize, keySet, i, idx, key, appTxn_1, appTxn;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    parsedVAA = parseVAA(vaa);
                    console.log(Number(parsedVAA.get("sequence")));
                    seq = Math.floor(Number(parsedVAA.get("sequence")) / MAX_BITS);
                    chainRaw = parsedVAA.get("chainRaw");
                    em = parsedVAA.get("emitter");
                    index = parsedVAA.get("index");
                    console.log(parsedVAA);
                    return [4 /*yield*/, optin(client, sender, appid, seq, chainRaw + em, "seqAddr")];
                case 1:
                    seqAddr = _a.sent();
                    guardianPgmName = textToHexString("guardian");
                    return [4 /*yield*/, optin(client, sender, CORE_ID, index, guardianPgmName, "guardianAddr")];
                case 2:
                    guardianAddr = _a.sent();
                    accts = [seqAddr, guardianAddr];
                    return [4 /*yield*/, decodeLocalState(client, CORE_ID, guardianAddr)];
                case 3:
                    keys = _a.sent();
                    return [4 /*yield*/, client
                            .getTransactionParams()
                            .do()];
                case 4:
                    params = _a.sent();
                    txns = [];
                    digest = keccak256(keccak256(parsedVAA.get("digest"))).slice(2);
                    numSigs = parsedVAA.get("siglen");
                    numTxns = Math.floor(numSigs / MAX_SIGS_PER_TXN) + 1;
                    SIG_LEN = 66;
                    BSIZE = SIG_LEN * MAX_SIGS_PER_TXN;
                    signatures = parsedVAA.get("signatures");
                    verifySigArg = textToUint8Array("verifySigs");
                    for (nt = 0; nt < numTxns; nt++) {
                        sigs = signatures.slice(nt * BSIZE);
                        if (sigs.length > BSIZE) {
                            sigs = sigs.slice(0, BSIZE);
                        }
                        GuardianKeyLen = 20;
                        numSigsThisTxn = sigs.length / SIG_LEN;
                        arraySize = numSigsThisTxn * GuardianKeyLen;
                        keySet = new Uint8Array(arraySize);
                        for (i = 0; i < numSigsThisTxn; i++) {
                            idx = sigs[i * SIG_LEN];
                            key = keys.slice(idx * GuardianKeyLen + 1, (idx + 1) * GuardianKeyLen + 1);
                            keySet.set(key, i * 20);
                        }
                        console.log("xxx", keySet);
                        appTxn_1 = makeApplicationCallTxnFromObject({
                            appArgs: [
                                verifySigArg,
                                sigs,
                                keySet,
                                hexStringToUint8Array(digest),
                            ],
                            accounts: accts,
                            appIndex: CORE_ID,
                            from: ALGO_VERIFY_HASH,
                            onComplete: OnApplicationComplete.NoOpOC,
                            suggestedParams: params,
                        });
                        appTxn_1.fee = 0;
                        txns.push(appTxn_1);
                    }
                    appTxn = makeApplicationCallTxnFromObject({
                        appArgs: [textToUint8Array("verifyVAA"), vaa],
                        accounts: accts,
                        appIndex: CORE_ID,
                        from: sender.addr,
                        onComplete: OnApplicationComplete.NoOpOC,
                        suggestedParams: params,
                    });
                    appTxn.fee = appTxn.fee * (1 + numTxns);
                    txns.push(appTxn);
                    return [2 /*return*/, new SubmitVAAState(parsedVAA, accts, txns, guardianAddr)];
            }
        });
    });
}
/**
 * <p>Groups the transactions together, signs them, sends them, waits for a confirmation</p>
 * @param client AlgodV2 client
 * @param sender Sending account
 * @param txns One or more transactions to send
 * @returns Confirmation log
 */
export function simpleSignVAA(client, sender, txns) {
    return __awaiter(this, void 0, void 0, function () {
        var signedTxns, resp, ret, response, isComplete;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("simpleSignVAA");
                    //    console.log(txns)
                    assignGroupID(txns);
                    signedTxns = [];
                    txns.forEach(function (txn) {
                        var _a;
                        console.log(txn);
                        if (txn.appArgs &&
                            ((_a = txn.appArgs) === null || _a === void 0 ? void 0 : _a.length) > 0 &&
                            JSON.stringify(txn.appArgs[0]) ===
                                JSON.stringify(textToUint8Array("verifySigs"))) {
                            console.log("Signing logic sig...");
                            var lsa = new LogicSigAccount(ALGO_VERIFY);
                            var stxn = signLogicSigTransaction(txn, lsa);
                            signedTxns.push(stxn.blob);
                        }
                        else {
                            console.log("Signing normal txn...");
                            signedTxns.push(txn.signTxn(sender.sk));
                        }
                    });
                    return [4 /*yield*/, client.sendRawTransaction(signedTxns).do()];
                case 1:
                    resp = _a.sent();
                    ret = [];
                    console.log("waitForConfirmation...");
                    return [4 /*yield*/, waitForConfirmation(client, txns[txns.length - 1].txID(), 1)];
                case 2:
                    response = _a.sent();
                    console.log(".. done");
                    console.log("submitVAA confirmation", response);
                    if (response["logs"]) {
                        ret.push(response["logs"]);
                    }
                    ret.forEach(function (log) {
                        console.log("logs:", log);
                    });
                    return [4 /*yield*/, getIsTransferCompletedAlgorand(client, signedTxns[0], TOKEN_BRIDGE_ID, sender)];
                case 3:
                    isComplete = _a.sent();
                    console.log("getIsTransferCompletedAlgorand result =", isComplete);
                    return [2 /*return*/, ret];
            }
        });
    });
}
/**
 * </p>Submits the VAA to the application
 * @param vaa The VAA to be submitted
 * @param client AlgodV2 client
 * @param sender Sending account
 * @param appid Application ID
 * @returns Confirmation log
 */
export function submitVAA(vaa, client, sender, appid) {
    return __awaiter(this, void 0, void 0, function () {
        var sstate, parsedVAA, accts, txns, ngsi, guardianPgmName, newGuardianAddr, meta, chainAddr, contract, assetId, params, asset, foreignAssets, tmp, buf, foreignAssets, a, asset, tmp, tmp, addr, ret;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, submitVAAHdr(vaa, client, sender, appid)];
                case 1:
                    sstate = _a.sent();
                    parsedVAA = sstate.vaaMap;
                    accts = sstate.accounts;
                    txns = sstate.txns;
                    if (!(parsedVAA.get("Meta") === "CoreGovernance" &&
                        parsedVAA.get("action") === 2)) return [3 /*break*/, 3];
                    ngsi = parsedVAA.get("NewGuardianSetIndex");
                    guardianPgmName = textToHexString("guardian");
                    return [4 /*yield*/, optin(client, sender, CORE_ID, ngsi, guardianPgmName, "newGuardianAddr")];
                case 2:
                    newGuardianAddr = _a.sent();
                    accts.push(newGuardianAddr);
                    _a.label = 3;
                case 3:
                    meta = parsedVAA.get("Meta");
                    chainAddr = "";
                    if (!(meta === "TokenBridge Attest" ||
                        meta === "TokenBridge Transfer" ||
                        meta === "TokenBridge Transfer With Payload")) return [3 /*break*/, 8];
                    if (!(parsedVAA.get("FromChain") != 8)) return [3 /*break*/, 5];
                    return [4 /*yield*/, optin(client, sender, TOKEN_BRIDGE_ID, parsedVAA.get("FromChain"), parsedVAA.get("Contract"), "TokenBridge chainAddr")];
                case 4:
                    chainAddr = _a.sent();
                    return [3 /*break*/, 7];
                case 5:
                    contract = parsedVAA.get("Contract");
                    assetId = contract.readIntBE(0, 4);
                    return [4 /*yield*/, optin(client, sender, TOKEN_BRIDGE_ID, assetId, textToHexString("native"), "TokenBridge native chainAddr")];
                case 6:
                    chainAddr = _a.sent();
                    _a.label = 7;
                case 7:
                    accts.push(chainAddr);
                    _a.label = 8;
                case 8: return [4 /*yield*/, client
                        .getTransactionParams()
                        .do()];
                case 9:
                    params = _a.sent();
                    if (meta === "CoreGovernance") {
                        txns.push(makeApplicationCallTxnFromObject({
                            appArgs: [textToUint8Array("governance"), vaa],
                            accounts: accts,
                            appIndex: CORE_ID,
                            from: sender.addr,
                            onComplete: OnApplicationComplete.NoOpOC,
                            suggestedParams: params,
                        }));
                        txns.push(makeApplicationCallTxnFromObject({
                            appArgs: [textToUint8Array("nop"), bigIntToBytes(5, 8)],
                            appIndex: CORE_ID,
                            from: sender.addr,
                            onComplete: OnApplicationComplete.NoOpOC,
                            suggestedParams: params,
                        }));
                    }
                    if (meta === "TokenBridge RegisterChain" ||
                        meta === "TokenBridge UpgradeContract") {
                        txns.push(makeApplicationCallTxnFromObject({
                            appArgs: [textToUint8Array("governance"), vaa],
                            accounts: accts,
                            appIndex: TOKEN_BRIDGE_ID,
                            foreignApps: [CORE_ID],
                            from: sender.addr,
                            onComplete: OnApplicationComplete.NoOpOC,
                            suggestedParams: params,
                        }));
                    }
                    if (!(meta === "TokenBridge Attest")) return [3 /*break*/, 11];
                    return [4 /*yield*/, decodeLocalState(client, TOKEN_BRIDGE_ID, chainAddr)];
                case 10:
                    asset = _a.sent();
                    foreignAssets = [];
                    if (asset.length > 8) {
                        tmp = Buffer.from(asset.slice(0, 8));
                        foreignAssets.push(Number(tmp.readBigUInt64BE(0)));
                    }
                    txns.push(makePaymentTxnWithSuggestedParamsFromObject({
                        from: sender.addr,
                        to: chainAddr,
                        amount: 100000,
                        suggestedParams: params,
                    }));
                    buf = new Uint8Array(1);
                    buf[0] = 0x01;
                    txns.push(makeApplicationCallTxnFromObject({
                        appArgs: [textToUint8Array("nop"), buf],
                        appIndex: TOKEN_BRIDGE_ID,
                        from: sender.addr,
                        onComplete: OnApplicationComplete.NoOpOC,
                        suggestedParams: params,
                    }));
                    buf[0] = 0x02;
                    txns.push(makeApplicationCallTxnFromObject({
                        appArgs: [textToUint8Array("nop"), buf],
                        appIndex: TOKEN_BRIDGE_ID,
                        from: sender.addr,
                        onComplete: OnApplicationComplete.NoOpOC,
                        suggestedParams: params,
                    }));
                    txns.push(makeApplicationCallTxnFromObject({
                        accounts: accts,
                        appArgs: [textToUint8Array("receiveAttest"), vaa],
                        appIndex: TOKEN_BRIDGE_ID,
                        foreignAssets: foreignAssets,
                        from: sender.addr,
                        onComplete: OnApplicationComplete.NoOpOC,
                        suggestedParams: params,
                    }));
                    txns[-1].fee = txns[-1].fee * 2;
                    _a.label = 11;
                case 11:
                    if (!(meta === "TokenBridge Transfer" ||
                        meta === "TokenBridge Transfer With Payload")) return [3 /*break*/, 15];
                    foreignAssets = [];
                    a = 0;
                    if (!(parsedVAA.get("FromChain") != 8)) return [3 /*break*/, 13];
                    return [4 /*yield*/, decodeLocalState(client, TOKEN_BRIDGE_ID, chainAddr)];
                case 12:
                    asset = _a.sent();
                    if (asset.length > 8) {
                        tmp = Buffer.from(asset.slice(0, 8));
                        a = Number(tmp.readBigUInt64BE(0));
                    }
                    return [3 /*break*/, 14];
                case 13:
                    tmp = Buffer.from(hexStringToUint8Array(parsedVAA.get("Contract")));
                    a = Number(tmp.readBigUInt64BE(0));
                    _a.label = 14;
                case 14:
                    addr = encodeAddress(hexStringToUint8Array(parsedVAA.get("ToAddress")));
                    if (a != 0) {
                        foreignAssets.push(a);
                        assetOptin(client, sender, foreignAssets[0], addr);
                        // And this is how the relayer gets paid...
                        if (parsedVAA.get("Fee") != ZERO_PAD_BYTES) {
                            assetOptin(client, sender, foreignAssets[0], sender.addr);
                        }
                    }
                    accts.push(addr);
                    txns.push(makeApplicationCallTxnFromObject({
                        accounts: accts,
                        appArgs: [textToUint8Array("receiveTransfer"), vaa],
                        appIndex: TOKEN_BRIDGE_ID,
                        foreignAssets: foreignAssets,
                        from: sender.addr,
                        onComplete: OnApplicationComplete.NoOpOC,
                        suggestedParams: params,
                    }));
                    // We need to cover the inner transactions
                    if (parsedVAA.get("Fee") != ZERO_PAD_BYTES) {
                        txns[-1].fee = txns[-1].fee * 3;
                    }
                    else {
                        txns[-1].fee = txns[-1].fee * 2;
                    }
                    _a.label = 15;
                case 15:
                    console.log("simpleSignVAA start");
                    return [4 /*yield*/, simpleSignVAA(client, sender, txns)];
                case 16:
                    ret = _a.sent();
                    console.log("simpleSignVAA done");
                    return [2 /*return*/, ret];
            }
        });
    });
}
export function getVAA(client, sender, sid, app) {
    return __awaiter(this, void 0, void 0, function () {
        var sAddr, params, txns, signedTxns, txn, txId, retVal, nextToken, done, response, transactions, numTransactions;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!sid) {
                        throw new Error("getVAA called with a sid of None");
                    }
                    sAddr = getApplicationAddress(app);
                    return [4 /*yield*/, client
                            .getTransactionParams()
                            .do()];
                case 1:
                    params = _a.sent();
                    // SOOO, we send a nop txn through to push the block forward one
                    // This is ONLY needed on a local net...  the indexer will sit
                    // on the last block for 30 to 60 seconds... we don't want this
                    // log in prod since it is wasteful of gas
                    if (IndexerInfo.getInstance().round > 512) {
                        // until they fix it
                        console.log("indexer is broken in local net... stop/clean/restart the sandbox");
                        throw new Error("Indexer > 512");
                    }
                    console.log("getVAA");
                    txns = [];
                    signedTxns = [];
                    txn = makeApplicationCallTxnFromObject({
                        from: sender.addr,
                        appIndex: TOKEN_BRIDGE_ID,
                        onComplete: OnApplicationComplete.NoOpOC,
                        appArgs: [textToUint8Array("nop")],
                        suggestedParams: params,
                    });
                    txns.push(txn);
                    signedTxns.push(txn.signTxn(sender.sk));
                    return [4 /*yield*/, client.sendRawTransaction(signedTxns).do()];
                case 2:
                    txId = (_a.sent()).txId;
                    retVal = new Uint8Array();
                    nextToken = "";
                    done = false;
                    _a.label = 3;
                case 3:
                    if (!true) return [3 /*break*/, 5];
                    return [4 /*yield*/, IndexerInfo.getInstance()
                            .client.searchForTransactions()
                            .nextToken(nextToken)
                            .minRound(1)
                            .notePrefix(textToUint8Array("publishMessage"))
                            .do()];
                case 4:
                    response = _a.sent();
                    transactions = response["transactions"];
                    console.log("outer transaction:", transactions);
                    transactions.forEach(function (element) {
                        // console.log("transaction element:", element);
                        var innerTxns = element["inner-txns"];
                        console.log("innerTxns:", innerTxns);
                        innerTxns.forEach(function (el) {
                            var at = el["application-transaction"];
                            // console.log("checking at:", at);
                            if (!at)
                                return;
                            // console.log("checking app id:", at["application-id"]);
                            // if (at["application-id"] != CORE_ID) return;
                            var logs = at["logs"];
                            if (!logs || logs.length == 0)
                                return;
                            console.log("checking logs:", at["logs"]);
                            var args = at["application-args"];
                            if (args) {
                                console.log("checking args:", at["application-args"]);
                            }
                            if (args.length < 2)
                                return;
                            if (Buffer.from(args[0], "base64").toString("hex") !=
                                textToHexString("publishMessage")) {
                                return;
                            }
                            var seq = parseSeqFromLog(element);
                            if (seq != sid)
                                return;
                            if (el["sender"] != sAddr)
                                return;
                            var emitter = decodeAddress(el["sender"]);
                            var payload = Buffer.from(args[1], "base64");
                            // pprint.pprint([seq, y["sender"], payload.hex()])
                            // retVal = self.gt.genVaa(emitter, seq, payload);
                            done = true;
                            return;
                        });
                        if (done)
                            return;
                    });
                    if (done)
                        return [3 /*break*/, 5];
                    numTransactions = transactions.length;
                    console.log("numTransactions", numTransactions, "next-token", nextToken);
                    if (response["next-token"]) {
                        nextToken = response["next-token"];
                        console.log("setting nextToken to", nextToken);
                    }
                    else {
                        IndexerInfo.getInstance().round = response["current-round"] + 1;
                        console.log("publishMessage = ", textToHexString("publishMessage"));
                        return [3 /*break*/, 5];
                    }
                    return [3 /*break*/, 3];
                case 5: return [2 /*return*/, retVal];
            }
        });
    });
}
/**
 * <p>Transfers an asset from Algorand to a receiver on another chain</p>
 * @param client AlgodV2 client
 * @param sender Sending account
 * @param assetId Asset index
 * @param qty Quantity to transfer
 * @param receiver Receiving account
 * @param chain Reeiving chain
 * @param fee Transfer fee
 * @returns Sequence number of confirmation
 */
export function transferAsset(client, sender, assetId, qty, receiver, chain, fee) {
    return __awaiter(this, void 0, void 0, function () {
        var tokenAddr, applAddr, emitterAddr, assetInfo, authAddr, wormhole, creator, creatorAcctInfo, params, txns, msgFee, payTxn, bNat, payTxn, bOptin, txn, t, accounts, t_1, t_2, args, acTxn, resp;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    tokenAddr = getApplicationAddress(TOKEN_BRIDGE_ID);
                    applAddr = appIdToAppAddr(TOKEN_BRIDGE_ID);
                    return [4 /*yield*/, optin(client, sender, CORE_ID, 0, applAddr, "transferAsset")];
                case 1:
                    emitterAddr = _a.sent();
                    return [4 /*yield*/, client
                            .getAssetByID(assetId)
                            .do()];
                case 2:
                    assetInfo = _a.sent();
                    authAddr = assetInfo["auth-addr"];
                    wormhole = false;
                    if (!(assetId != 0)) return [3 /*break*/, 4];
                    creator = assetInfo["params"]["creator"];
                    return [4 /*yield*/, client.accountInformation(creator).do()];
                case 3:
                    creatorAcctInfo = _a.sent();
                    if (authAddr === tokenAddr) {
                        wormhole = true;
                    }
                    _a.label = 4;
                case 4: return [4 /*yield*/, client
                        .getTransactionParams()
                        .do()];
                case 5:
                    params = _a.sent();
                    txns = [];
                    return [4 /*yield*/, getMessageFee(client)];
                case 6:
                    msgFee = _a.sent();
                    if (msgFee > 0) {
                        payTxn = makePaymentTxnWithSuggestedParamsFromObject({
                            from: sender.addr,
                            suggestedParams: params,
                            to: getApplicationAddress(TOKEN_BRIDGE_ID),
                            amount: msgFee,
                        });
                        txns.push(payTxn);
                    }
                    if (!!wormhole) return [3 /*break*/, 8];
                    bNat = Buffer.from("native", "binary").toString("hex");
                    return [4 /*yield*/, optin(client, sender, TOKEN_BRIDGE_ID, assetId, bNat, "creator")];
                case 7:
                    creator = _a.sent();
                    _a.label = 8;
                case 8:
                    if (!(assetId != 0 && !assetOptinCheck(client, assetId, creator))) return [3 /*break*/, 10];
                    payTxn = makePaymentTxnWithSuggestedParamsFromObject({
                        from: sender.addr,
                        to: creator,
                        amount: 100000,
                        suggestedParams: params,
                    });
                    txns.push(payTxn);
                    bOptin = Buffer.from("optin", "binary");
                    txn = makeApplicationCallTxnFromObject({
                        from: sender.addr,
                        appIndex: TOKEN_BRIDGE_ID,
                        onComplete: OnApplicationComplete.NoOpOC,
                        appArgs: [bOptin, bigIntToBytes(assetId, 8)],
                        foreignAssets: [assetId],
                        accounts: [creator],
                        suggestedParams: params,
                    });
                    txn.fee *= 2;
                    txns.push(txn);
                    return [4 /*yield*/, simpleSignVAA(client, sender, txns)];
                case 9:
                    _a.sent();
                    txns = [];
                    _a.label = 10;
                case 10:
                    t = makeApplicationCallTxnFromObject({
                        from: sender.addr,
                        appIndex: TOKEN_BRIDGE_ID,
                        onComplete: OnApplicationComplete.NoOpOC,
                        appArgs: [textToUint8Array("nop")],
                        suggestedParams: params,
                    });
                    txns.push(t);
                    accounts = [];
                    if (assetId === 0) {
                        t_1 = makePaymentTxnWithSuggestedParamsFromObject({
                            from: sender.addr,
                            to: creator,
                            amount: qty,
                            suggestedParams: params,
                        });
                        txns.push(t_1);
                        accounts = [emitterAddr, creator, creator];
                    }
                    else {
                        t_2 = makeAssetTransferTxnWithSuggestedParamsFromObject({
                            from: sender.addr,
                            to: creator,
                            suggestedParams: params,
                            amount: qty,
                            assetIndex: assetId,
                        });
                        txns.push(t_2);
                        accounts = [emitterAddr, creator, creatorAcctInfo["address"]];
                    }
                    args = [
                        textToUint8Array("sendTransfer"),
                        bigIntToBytes(assetId, 8),
                        bigIntToBytes(qty, 8),
                        decodeAddress(receiver.addr).publicKey,
                        bigIntToBytes(chain, 8),
                        bigIntToBytes(fee, 8),
                    ];
                    acTxn = makeApplicationCallTxnFromObject({
                        from: sender.addr,
                        appIndex: TOKEN_BRIDGE_ID,
                        onComplete: OnApplicationComplete.NoOpOC,
                        appArgs: args,
                        foreignApps: [CORE_ID],
                        foreignAssets: [assetId],
                        accounts: accounts,
                        suggestedParams: params,
                    });
                    acTxn.fee *= 2;
                    txns.push(acTxn);
                    return [4 /*yield*/, simpleSignVAA(client, sender, txns)];
                case 11:
                    resp = _a.sent();
                    return [2 /*return*/, parseSeqFromLog(resp)];
            }
        });
    });
}
export function createWrappedOnAlgorand(client, sender, attestVAA) {
    submitVAA(attestVAA, client, sender, TOKEN_BRIDGE_ID);
}
export function updateWrappedOnAlgorand(client, sender, vaa) {
    submitVAA(vaa, client, sender, TOKEN_BRIDGE_ID);
}
/**
 * <p>This basically just submits the VAA to Algorand</p>
 * @param vaa The VAA to be redeemed
 * @param client AlgodV2 client
 * @param acct Sending account
 * @param tokenId Token bridge ID
 * @returns Transaction ID(s)
 */
export function redeemOnAlgorand(vaa, client, acct, tokenId) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, submitVAA(vaa, client, acct, tokenId)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
/**
 * <p>This function is used to check if a VAA has been redeemed by looking at a specific bit.<p>
 * @param client AlgodV2 client
 * @param appId Application Id
 * @param addr Some address. TODO:  What is the relationship to the VAA?
 * @param seq The sequence number of the redemption
 * @returns true, if the bit was set and VAA was redeemed, false otherwise.
 */
function checkBitsSet(client, appId, addr, seq) {
    return __awaiter(this, void 0, void 0, function () {
        var retval, appState, acctInfo, als, BIG_MAX_BITS, BIG_EIGHT, start, beg, s, b, key;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    retval = false;
                    appState = [];
                    return [4 /*yield*/, client.accountInformation(addr).do()];
                case 1:
                    acctInfo = _a.sent();
                    als = acctInfo["apps-local-state"];
                    als.forEach(function (app) {
                        if (app["id"] === appId) {
                            appState = app["key-value"];
                        }
                    });
                    if (appState.length === 0) {
                        console.log("appState is empty");
                        return [2 /*return*/, retval];
                    }
                    BIG_MAX_BITS = BigInt(MAX_BITS);
                    BIG_EIGHT = BigInt(8);
                    start = (seq / BIG_MAX_BITS) * BIG_MAX_BITS;
                    beg = Number(seq - start);
                    s = Math.floor(beg / BITS_PER_KEY);
                    b = Math.floor((beg - s * BITS_PER_KEY) / 8);
                    key = Buffer.from(bigIntToBytes(s, 8)).toString("base64");
                    console.log("key:", key);
                    appState.forEach(function (kv) {
                        if (kv["key"] === key) {
                            var v = Buffer.from(kv["value"]["bytes"], "base64");
                            var bt = 1 << Number(seq % BIG_EIGHT);
                            retval = (v[b] & bt) != 0;
                            return;
                        }
                    });
                    return [2 /*return*/, retval];
            }
        });
    });
}
/////////// These need to be written
export function getForeignAssetAlgorand(client, algoTokenBridgeAddress, orginChain, originAsset) {
    return __awaiter(this, void 0, void 0, function () {
        var assetInfo, retVal;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, IndexerInfo.getInstance()
                        .client.searchForAssets()
                        .do()];
                case 1:
                    assetInfo = _a.sent();
                    retVal = "";
                    return [2 /*return*/, retVal];
            }
        });
    });
}
/**
 *
 * @param client AlgodV2 client
 * @param signedVAA VAA to check
 * @param appId Most likely the Token bridge ID
 * @param wallet The account paying the bill for this (it isn't free)
 * @returns true if VAA has been redeemed, false otherwise
 */
export function getIsTransferCompletedAlgorand(client, signedVAA, appId, wallet) {
    return __awaiter(this, void 0, void 0, function () {
        var parsedVAA, seq, chainRaw, em, index, seqAddr, retVal;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    parsedVAA = parseVAA(signedVAA);
                    console.log(Number(parsedVAA.get("sequence")));
                    seq = Math.floor(Number(parsedVAA.get("sequence")) / MAX_BITS);
                    chainRaw = parsedVAA.get("chainRaw");
                    em = parsedVAA.get("emitter");
                    index = parsedVAA.get("index");
                    console.log(parsedVAA);
                    return [4 /*yield*/, optin(client, wallet, appId, seq, chainRaw + em, "Getting seqAddr from getIsTransferCompletedAlgorand")];
                case 1:
                    seqAddr = _a.sent();
                    console.log("seqAddr:", seqAddr);
                    return [4 /*yield*/, checkBitsSet(client, appId, seqAddr, BigInt(seq))];
                case 2:
                    retVal = _a.sent();
                    return [2 /*return*/, retVal];
            }
        });
    });
}
export function getIsWrappedAssetAlgorand() {
    // TODO:
}
export function hexToNativeString() {
    // TODO:
    // Add the algorand case to sdk/js/src/utils/array.ts
}
export function nativeToHexString() {
    // TODO:
    // Add the algorand case to sdk/js/src/utils/array.ts
}
/**
 * <p>Transfer the amount of an asset from Algorand to a different chain</p>
 * @param client AlgodV2 client
 * @param sender Holder of the asset
 * @param assetId Asset index on Algorand
 * @param quantity Amount to be transferred
 * @param receiver Receiving account
 * @param chain Receiving chain ID
 * @param fee Message fee to be paid
 */
export function transferFromAlgorand(client, sender, assetId, quantity, receiver, chain, fee) {
    return __awaiter(this, void 0, void 0, function () {
        var sid, vaa;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, transferAsset(client, sender, assetId, quantity, receiver, chain, fee)];
                case 1:
                    sid = _a.sent();
                    return [4 /*yield*/, getVAA(client, sender, sid, TOKEN_BRIDGE_ID)];
                case 2:
                    vaa = _a.sent();
                    // print(".. and lets pass that to player3")
                    // vaaLogs.append(["transferFromAlgorand", vaa])
                    // #pprint.pprint(vaaLogs)
                    submitVAA(vaa, client, sender, TOKEN_BRIDGE_ID);
                    return [2 /*return*/];
            }
        });
    });
}
